﻿Public Class FrmQuiz

    'http://www.paulsquiz.com/free_quiz_questions/other_trivia_quizzes/Multiple_Choice_Quiz_1/

    Dim CurrentQuestionIndex As Integer = 0     'tracks the number of questions asked -- starts at 0
    Dim QuestionIndex As Integer()              'shuffled set of indices -- put questions in random order
    Dim myRandom As Random                      'random object -- allows questions and answers to be put 
    'in pseudo-random order
    Dim CounterRight As Integer = 0             'tracks number of questions the user answered correctly 
    Dim CorrectAnswer As String()               'keeps track of correct answers


    Dim Question As String() = New String() {"What do the Danish call Danish pastries:", _
            "The German word kummerspeck, meaning weight gained through comfort eating, literally means what:", _
            "A swede is:", _
            "Which of these was once the national drink of Scotland?", _
            "Which of the following was a predecessor of the Milky Way bar:", _
            "According to the International Cloud Atlas, which of these is the highest?", _
            "Which is the deepest loch in Scotland:", _
            "What was the first of Earth's supercontinents:", _
             "In which country was the Can-Can invented:", _
             "The word absinthe comes from the Greek apsinthion, meaning what:"}

    Dim Choices As String() = New String() {"Viennese Bread|Alsatian cakes|Danishpastries", _
            "Grief bacon|Cream guzzling|Disappointment candy", _
            "A cross between a cabbage and a turnip|A cross between a parsnip and a beetroot| A cross between fennel and carrots", _
            "Claret|Amaretto|Vodka", _
            "Fat Emma|Lardy Larry|Penny Plump", _
            "Cloud zero|Cloud nine|Fog", _
            "Loch Morar|Loch Lomand|Loch Ness", _
            "Rodinia|Pangaea|Gondwanaland", _
             "France|UK|Canada", _
             "Undrinkable|Green Monster|Vomiting"}


    '**********************************************************
    'make an array of indices and shuffle them up so we can 
    'ask the questions in a random order
    Private Sub FrmQuiz_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer
        Dim j As Integer
        Dim SwapIndex As Integer


        myRandom = New Random

        CorrectAnswer = New String(Question.Length - 1) {}
        QuestionIndex = New Integer(Question.Length - 1) {}


        'instead of shuffling the question and choice arrays
        'we can make an array of indices and shuffle that
        For i = 0 To QuestionIndex.Length - 1
            QuestionIndex(i) = i
        Next

        'shuffle the index array
        For i = 0 To QuestionIndex.Length - 1
            j = myRandom.Next(0, QuestionIndex.Length)
            SwapIndex = QuestionIndex(i)
            QuestionIndex(i) = QuestionIndex(j)
            QuestionIndex(j) = SwapIndex
        Next

        'call display method
        DisplayQuestion()

    End Sub


    '************************************************************************************
    'check user's answer against the correct answer 
    Private Sub btnCheck_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheck.Click
        Dim i As Integer
        Dim MyRadioButton As RadioButton
        Dim UserAnswer As String = ""

        'get ready for next part -- which will be moving to the next question
        btnCheck.Visible = False
        btnNext.Visible = True

        'loop through radiobuttons get answer from selected radiobutton
        For i = 0 To grbChoices.Controls.Count - 1
            MyRadioButton = grbChoices.Controls.Item(i)
            MyRadioButton.Enabled = False

            If MyRadioButton.Checked Then
                'MsgBox(MyRadioButton.Text)
                UserAnswer = MyRadioButton.Text
            End If
        Next

        'see if the user answered and if so if that answer is correct
        If UserAnswer = "" Then
            MsgBox("Make a guess.")
            Exit Sub
        ElseIf UserAnswer = CorrectAnswer(QuestionIndex(CurrentQuestionIndex)) Then
            'MsgBox("right")
            CounterRight += 1
        Else
            'MsgBox("wrong")
        End If

        'display progress/grade
        lblGrade.Text = "You've got " & CounterRight & " out of " & _
            (CurrentQuestionIndex + 1)


    End Sub

    '*********************************************************************************
    'user moves to next question
    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        'get ready for the next step which will be checking an answer
        btnCheck.Visible = True
        btnNext.Visible = False

        CurrentQuestionIndex += 1
        DisplayQuestion()
    End Sub

    '********************************************************************************
    'display question and possible answers
    Private Sub DisplayQuestion()
        Dim ThisQuestionChoices As String
        Dim IndividualChoices As String()
        Dim i As Integer
        Dim j As Integer

        'display question
        lblQuestion.Text = Question(QuestionIndex(CurrentQuestionIndex))

        'get corresponding answers
        ThisQuestionChoices = Choices(QuestionIndex(CurrentQuestionIndex))
        'MsgBox(ThisQuestionChoices)

        'parse answer string into individual choices
        IndividualChoices = ThisQuestionChoices.Split("|")

        'before shuffling -- first answer is correct one
        CorrectAnswer(QuestionIndex(CurrentQuestionIndex)) = IndividualChoices(0)

        'shuffle answers
        Dim SwapAnswer As String
        For i = 0 To IndividualChoices.Length - 1
            j = myRandom.Next(0, IndividualChoices.Length)
            SwapAnswer = IndividualChoices(i)
            IndividualChoices(i) = IndividualChoices(j)
            IndividualChoices(j) = SwapAnswer
        Next

        'deselct any previous radiobutton selections
        'put down new answers
        Dim MyradioButton As RadioButton
        For i = 0 To grbChoices.Controls.Count - 1
            MyRadioButton = grbChoices.Controls.Item(i)
            MyradioButton.Enabled = True
            MyradioButton.Checked = False
            MyradioButton.Text = IndividualChoices(i)
        Next

    End Sub

End Class
